## onevpl 2023.1.1

=== CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
# oneAPI Video Processing Library (oneVPL) main build script
if(MSVC)
  cmake_minimum_required(VERSION 3.15)
  cmake_policy(SET CMP0091 NEW)
else()
  cmake_minimum_required(VERSION 3.10.2)
endif()

file(STRINGS "version.txt" version_txt)
project(vpl VERSION ${version_txt})

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_SOURCE_DIR}/cmake")

#
# Project configuration options
#

# Set default build type to Release if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Default CMAKE_BUILD_TYPE not set using Release")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

# More code hardening on Windows
if(MSVC)
  if(${use_control_flow_guard})
    message("Setting CONTROL FLOW GUARD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
    set(CMAKE_EXE_LINKER_FLAGS "/guard:cf /DYNAMICBASE")
  endif()
  if(${use_qspectre})
    message("Setting QSPECTRE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
  endif()
endif()

# WA for missing definition in 32-bit arm-linux compiler
string(FIND ${CMAKE_CXX_COMPILER} "arm-linux" IS_ARM_32BIT)
if(${IS_ARM_32BIT} GREATER_EQUAL 0)
  message(STATUS "Setting __ILP32__")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__ILP32__")
endif()

# Project options
option(BUILD_SHARED_LIBS "Build shared instead of static libraries." ON)
option(BUILD_TESTS "Build tests." OFF)

set(BUILD_DEV
    ON
    CACHE BOOL "Build files that are only needed for development.")
set(BUILD_DISPATCHER
    ON
    CACHE BOOL "Build dispatcher.")
set(BUILD_TOOLS
    ON
    CACHE BOOL "Build tools.")
set(BUILD_EXAMPLES
    OFF
    CACHE BOOL "Build examples when building dev package.")
set(BUILD_PREVIEW
    ON
    CACHE BOOL "Build preview features.")
set(INSTALL_EXAMPLE_CODE
    ON
    CACHE BOOL "Install examples when installing dev package.")

set(BUILD_DISPATCHER_ONEVPL_EXPERIMENTAL
    ON
    CACHE BOOL "Build dispatcher with ONEVPL_EXPERIMENTAL APIs.")

set(BUILD_TOOLS_ONEVPL_EXPERIMENTAL
    ON
    CACHE BOOL "Build tools with ONEVPL_EXPERIMENTAL APIs.")

option(BUILD_DISPATCHER_ONLY "Build dispatcher only." OFF)
option(BUILD_DEV_ONLY "Build only developer package." OFF)

if(BUILD_DISPATCHER_ONLY)
  set(BUILD_DEV OFF)
  set(BUILD_PREVIEW OFF)
  set(BUILD_TOOLS OFF)
  set(BUILD_TOOLS_ONEVPL_EXPERIMENTAL OFF)
  set(INSTALL_EXAMPLE_CODE OFF)
  set(BUILD_DISPATCHER ON)

endif()
if(BUILD_DEV_ONLY)
  set(BUILD_DISPATCHER OFF)
  set(BUILD_TOOLS OFF)
endif()

option(USE_MSVC_STATIC_RUNTIME
       "Link MSVC runtime statically to all components." OFF)

if(USE_MSVC_STATIC_RUNTIME)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()

option(USE_ONEAPI_INSTALL_LAYOUT "Use oneAPI install layout instead of FHS" OFF)

# Set output directories
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

include(cmake/oneAPIInstallDirs.cmake)

# Set POSITION_INDEPENDENT_CODE property for all targets
set(CMAKE_POSITION_INDEPENDENT_CODE true)

# Keep executable bits on shared objects when installing regardless of distro
set(CMAKE_INSTALL_SO_NO_EXE 0)

include(cmake/CompileOptions.cmake)

if(BUILD_TESTS)
  include(Dart)
  enable_testing()
endif()

add_subdirectory(api)
add_subdirectory(dispatcher)
if(BUILD_TOOLS)
  add_subdirectory(tools)
endif()
if(BUILD_DEV)
  add_subdirectory(env)
  add_subdirectory(modulefiles)
  add_subdirectory(examples)
endif()

install(
  FILES third-party-programs.txt
  DESTINATION ${ONEAPI_INSTALL_LICENSEDIR}
  COMPONENT license)

install(
  FILES LICENSE
  RENAME license.txt
  DESTINATION ${ONEAPI_INSTALL_LICENSEDIR}
  COMPONENT license)

if(USE_ONEAPI_INSTALL_LAYOUT)
  install(
    FILES LICENSE
    RENAME license.txt
    DESTINATION "licensing"
    COMPONENT license)
endif()

include(cmake/PackageTarget.cmake)
set(CMAKE_INSTALL_SYSTEM_RUNTIME_COMPONENT runtime)
include(InstallRequiredSystemLibraries)

message(
  STATUS "---------------- Configuration summary ------------------------------"
)
message(STATUS "CMake:")
message(STATUS "  CMAKE_VERSION                   : ${CMAKE_VERSION}")
message(STATUS "  CMAKE_GENERATOR                 : ${CMAKE_GENERATOR}")
message(STATUS "  CMAKE_BUILD_TOOL                : ${CMAKE_BUILD_TOOL}")
message(STATUS "Target:")
message(STATUS "  CMAKE_SYSTEM_NAME               : ${CMAKE_SYSTEM_NAME}")
message(STATUS "  CMAKE_SYSTEM_VERSION            : ${CMAKE_SYSTEM_VERSION}")
message(STATUS "  CMAKE_SYSTEM_PROCESSOR          : ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "General:")
message(STATUS "  CMAKE_BUILD_TYPE                : ${CMAKE_BUILD_TYPE}")
message(STATUS "  CMAKE_TOOLCHAIN_FILE            : ${CMAKE_TOOLCHAIN_FILE}")
message(STATUS "  CMAKE_C_COMPILER                : ${CMAKE_C_COMPILER}")
message(STATUS "  CMAKE_CXX_COMPILER              : ${CMAKE_CXX_COMPILER}")
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(STATUS "  Build architecture              : 64-bit")
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  message(STATUS "  Build architecture              : 32-bit")
endif()
message(STATUS "Flags:")
message(STATUS "  CMAKE_C_FLAGS                   : ${CMAKE_C_FLAGS}")
message(STATUS "  CMAKE_CXX_FLAGS                 : ${CMAKE_CXX_FLAGS}")
message(STATUS "Release flags:")
message(STATUS "  CMAKE_C_FLAGS_RELEASE           : ${CMAKE_C_FLAGS_RELEASE}")
message(STATUS "  CMAKE_CXX_FLAGS_RELEASE         : ${CMAKE_CXX_FLAGS_RELEASE}")
message(STATUS "Debug flags:")
message(STATUS "  CMAKE_C_FLAGS_DEBUG             : ${CMAKE_C_FLAGS_DEBUG}")
message(STATUS "  CMAKE_CXX_FLAGS_DEBUG           : ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "RelWithDebRT flags:")
message(
  STATUS "  CMAKE_C_FLAGS_RELWITHDEBRT      : ${CMAKE_C_FLAGS_RELWITHDEBRT}")
message(
  STATUS "  CMAKE_CXX_FLAGS_RELWITHDEBRT    : ${CMAKE_CXX_FLAGS_RELWITHDEBRT}")
message(STATUS "Install:")
message(STATUS "  CMAKE_INSTALL_PREFIX            : ${CMAKE_INSTALL_PREFIX}")
message(
  STATUS "  CMAKE_INSTALL_FULL_BINDIR       : ${CMAKE_INSTALL_FULL_BINDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_INCLUDEDIR   : ${CMAKE_INSTALL_FULL_INCLUDEDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_LIBDIR       : ${CMAKE_INSTALL_FULL_LIBDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_DOCDIR       : ${CMAKE_INSTALL_FULL_DOCDIR}")
message(
  STATUS
    "  ONEAPI_INSTALL_FULL_PKGCONFIGDIR: ${ONEAPI_INSTALL_FULL_PKGCONFIGDIR}")
message(
  STATUS "  ONEAPI_INSTALL_FULL_CMAKEDIR    : ${ONEAPI_INSTALL_FULL_CMAKEDIR}")
message(
  STATUS "  ONEAPI_INSTALL_FULL_ENVDIR      : ${ONEAPI_INSTALL_FULL_ENVDIR}")
message(
  STATUS "  ONEAPI_INSTALL_FULL_MODFILEDIR  : ${ONEAPI_INSTALL_FULL_MODFILEDIR}"
)
message(
  STATUS "  ONEAPI_INSTALL_FULL_EXAMPLEDIR  : ${ONEAPI_INSTALL_FULL_EXAMPLEDIR}"
)
message(
  STATUS "  ONEAPI_INSTALL_FULL_LICENSEDIR  : ${ONEAPI_INSTALL_FULL_LICENSEDIR}"
)
message(
  STATUS "  ONEAPI_INSTALL_FULL_PYTHONDIR   : ${ONEAPI_INSTALL_FULL_PYTHONDIR}")
message(STATUS "Build:")
message(
  STATUS "  BUILD_DISPATCHER_ONLY                : ${BUILD_DISPATCHER_ONLY}")
message(STATUS "  BUILD_DEV                            : ${BUILD_DEV}")
message(STATUS "  BUILD_DISPATCHER                     : ${BUILD_DISPATCHER}")
message(STATUS "  BUILD_TOOLS                          : ${BUILD_TOOLS}")
if(CMAKE_SYSTEM_NAME MATCHES Linux)
  message(STATUS "  ENABLE_VA                            : ${ENABLE_VA}")
  message(STATUS "  ENABLE_DRM                           : ${ENABLE_DRM}")
  message(STATUS "  ENABLE_WAYLAND                       : ${ENABLE_WAYLAND}")
  message(STATUS "  ENABLE_X11                           : ${ENABLE_X11}")
  message(STATUS "  ENABLE_DRI3                          : ${ENABLE_DRI3}")
endif()
message(STATUS "  BUILD_SHARED_LIBS                    : ${BUILD_SHARED_LIBS}")
message(STATUS "  BUILD_TESTS                          : ${BUILD_TESTS}")
message(STATUS "  BUILD_EXAMPLES                       : ${BUILD_EXAMPLES}")
message(STATUS "  BUILD_PREVIEW                        : ${BUILD_PREVIEW}")
message(
  STATUS
    "  BUILD_DISPATCHER_ONEVPL_EXPERIMENTAL : ${BUILD_DISPATCHER_ONEVPL_EXPERIMENTAL}"
)
message(
  STATUS
    "  BUILD_TOOLS_ONEVPL_EXPERIMENTAL      : ${BUILD_TOOLS_ONEVPL_EXPERIMENTAL}"
)
message(
  STATUS "  INSTALL_EXAMPLE_CODE                 : ${INSTALL_EXAMPLE_CODE}")

if(MSVC)
  message(
    STATUS "  USE_MSVC_STATIC_RUNTIME              : ${USE_MSVC_STATIC_RUNTIME}"
  )
endif()

=== dispatcher/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)
set(TARGET VPL)
set(OUTPUT_NAME "vpl")
set(DLL_PREFIX "lib")
set(VERSION ${API_VERSION_MAJOR}.${API_VERSION_MINOR})

if(WIN32)
  set(SOURCES
      windows/main.cpp
      windows/mfx_critical_section.cpp
      windows/mfx_dispatcher.cpp
      windows/mfx_dispatcher_log.cpp
      windows/mfx_driver_store_loader.cpp
      windows/mfx_dxva2_device.cpp
      windows/mfx_function_table.cpp
      windows/mfx_library_iterator.cpp
      windows/mfx_load_dll.cpp
      windows/mfx_win_reg_key.cpp
      windows/libmfx.def)
  if(BUILD_SHARED_LIBS)
    configure_file(windows/version.rc.in windows/version.rc @ONLY)
    list(APPEND SOURCES ${CMAKE_CURRENT_BINARY_DIR}/windows/version.rc)
  endif()
endif()
if(UNIX)
  set(SOURCES linux/mfxloader.cpp)

  if(NOT DEFINED MFX_MODULES_DIR)
    set(MFX_MODULES_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
  endif()
  add_definitions(-DMFX_MODULES_DIR="${MFX_MODULES_DIR}")
  message(STATUS "MFX_MODULES_DIR=${MFX_MODULES_DIR}")
endif()

if(BUILD_DISPATCHER_ONEVPL_EXPERIMENTAL)
  add_definitions(-DONEVPL_EXPERIMENTAL)
endif()

list(
  APPEND
  SOURCES
  vpl/mfx_dispatcher_vpl.cpp
  vpl/mfx_dispatcher_vpl_loader.cpp
  vpl/mfx_dispatcher_vpl_config.cpp
  vpl/mfx_dispatcher_vpl_lowlatency.cpp
  vpl/mfx_dispatcher_vpl_log.cpp
  vpl/mfx_dispatcher_vpl_msdk.cpp)

add_library(${TARGET} "")

# disable warnings for dispatcher library itself but not subprojects (unit
# tests)
set_target_properties(${TARGET} PROPERTIES COMPILE_DEFINITIONS
                                           "MFX_DEPRECATED_OFF")

if(WIN32)
  # force libxxx style sharedlib name on Windows
  if(BUILD_SHARED_LIBS)
    set_target_properties(${TARGET} PROPERTIES PREFIX ${DLL_PREFIX})
  endif()
  set(SHLIB_FILE_NAME ${DLL_PREFIX}${OUTPUT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX})
  set(SHLIB_FILE_NAME_DEBUG
      ${DLL_PREFIX}${OUTPUT_NAME}${CMAKE_DEBUG_POSTFIX}${CMAKE_SHARED_LIBRARY_SUFFIX}
  )

else()
  # use version script on Linux
  set_target_properties(
    ${TARGET}
    PROPERTIES
      LINK_FLAGS
      "-Wl,--version-script=${CMAKE_CURRENT_SOURCE_DIR}/linux/libvpl.map")
  set(SHLIB_FILE_NAME
      ${CMAKE_SHARED_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}.${API_VERSION_MAJOR}
  )
  set(SHLIB_FILE_NAME_DEBUG ${SHLIB_FILE_NAME})
endif()

set(LIB_FILE_NAME
    ${CMAKE_STATIC_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_STATIC_LIBRARY_SUFFIX})
set(IMPLIB_FILE_NAME
    ${CMAKE_IMPORT_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_IMPORT_LIBRARY_SUFFIX})
set(LIB_FILE_NAME_DEBUG
    ${CMAKE_STATIC_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_DEBUG_POSTFIX}${CMAKE_STATIC_LIBRARY_SUFFIX}
)
set(IMPLIB_FILE_NAME_DEBUG
    ${CMAKE_IMPORT_LIBRARY_PREFIX}${OUTPUT_NAME}${CMAKE_DEBUG_POSTFIX}${CMAKE_IMPORT_LIBRARY_SUFFIX}
)

set_target_properties(
  ${TARGET}
  PROPERTIES OUTPUT_NAME ${OUTPUT_NAME} SOVERSION ${API_VERSION_MAJOR}
             VERSION ${API_VERSION_MAJOR}.${API_VERSION_MINOR})

target_sources(${TARGET} PRIVATE ${SOURCES})

if(UNIX)
  # require pthreads for loading legacy MSDK runtimes
  set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
  set(THREADS_PREFER_PTHREAD_FLAG TRUE)
  find_package(Threads REQUIRED)
  if(BUILD_SHARED_LIBS)
    target_link_libraries(${TARGET} PRIVATE Threads::Threads)
  else()
    target_link_libraries(${TARGET} PUBLIC Threads::Threads)
  endif()
endif()

target_link_libraries(${TARGET} PUBLIC vpl-api)
if(BUILD_SHARED_LIBS)
  target_link_libraries(${TARGET} PRIVATE ${CMAKE_DL_LIBS})
else()
  target_link_libraries(${TARGET} PUBLIC ${CMAKE_DL_LIBS})
endif()

target_include_directories(${TARGET} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
                                             ${CMAKE_CURRENT_BINARY_DIR})

if(BUILD_DISPATCHER)
  install(
    TARGETS ${TARGET}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT runtime
            NAMELINK_SKIP
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime)
endif()

if(BUILD_DEV)
  install(
    TARGETS ${TARGET}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT dev
            NAMELINK_ONLY)
  if(WIN32)
    install(TARGETS ${TARGET} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
                                      COMPONENT dev)
  endif()

  file(RELATIVE_PATH cmake_rel_prefix ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/vpl
       ${CMAKE_INSTALL_PREFIX})
  file(RELATIVE_PATH cmake_rel_libdir ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/vpl
       ${CMAKE_INSTALL_FULL_LIBDIR})
  file(RELATIVE_PATH cmake_rel_incdir ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/vpl
       ${CMAKE_INSTALL_FULL_INCLUDEDIR})
  file(RELATIVE_PATH cmake_rel_bindir ${CMAKE_INSTALL_FULL_LIBDIR}/cmake/vpl
       ${CMAKE_INSTALL_FULL_BINDIR})

  configure_file(cmake/VPLConfig.cmake.in cmake/VPLConfig.cmake @ONLY)
  configure_file(cmake/VPLConfigVersion.cmake.in cmake/VPLConfigVersion.cmake
                 @ONLY)

  install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/cmake/VPLConfig.cmake"
          "${CMAKE_CURRENT_BINARY_DIR}/cmake/VPLConfigVersion.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/vpl"
    COMPONENT dev)

  file(RELATIVE_PATH pc_rel_prefix ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
       ${CMAKE_INSTALL_PREFIX})
  file(RELATIVE_PATH pc_rel_libdir ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
       ${CMAKE_INSTALL_FULL_LIBDIR})
  file(RELATIVE_PATH pc_rel_incdir ${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig
       ${CMAKE_INSTALL_FULL_INCLUDEDIR})
  set(pc_rel_prefix "$\{pcfiledir}/${pc_rel_prefix}")
  set(pc_rel_libdir "$\{pcfiledir}/${pc_rel_libdir}")
  set(pc_rel_incdir "$\{pcfiledir}/${pc_rel_incdir}")

  if(CMAKE_DL_LIBS)
    set(DL_LIBS "-l${CMAKE_DL_LIBS}")
  endif()
  if(MINGW)
    # being conservative by restricting to MinGW, these are probably ok for
    # WIN32 in general
    set(MINGW_LIBS "-lole32 -lgdi32 -luuid")
  endif()
  if(NOT MSVC)
    set(CXX_LIB "-lstdc++")
  endif()
  set(VPL_PKGCONFIG_DEPENDENT_LIBS
      "${DL_LIBS} ${CMAKE_THREAD_LIBS_INIT} ${MINGW_LIBS} ${CXX_LIB}")
  configure_file("pkgconfig/vpl.pc.in" "pkgconfig/vpl.pc" @ONLY)
  install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/pkgconfig/vpl.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
    COMPONENT dev)
endif()

if(BUILD_TESTS)
  add_subdirectory(test)
endif()

=== env/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)

file(RELATIVE_PATH env_rel_prefix "${ONEAPI_INSTALL_FULL_ENVDIR}"
     "${CMAKE_INSTALL_PREFIX}")
# remove trailing slash
string(REGEX REPLACE "\/$" "" env_rel_prefix "${env_rel_prefix}")

# convert to native path
file(TO_NATIVE_PATH "${env_rel_prefix}" env_rel_prefix)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_INCLUDEDIR}" _install_includedir)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_LIBDIR}" _install_libdir)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_BINDIR}" _install_bindir)
file(TO_NATIVE_PATH "${ONEAPI_INSTALL_EXAMPLEDIR}" _install_exampledir)

if(WIN32)
  install(
    PROGRAMS "cmd/vars.bat"
    DESTINATION "${ONEAPI_INSTALL_ENVDIR}"
    COMPONENT dev)

  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(ENV_SCRIPT_NAME "vars64.bat")
  elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(ENV_SCRIPT_NAME "vars32.bat")
  endif()
  configure_file("cmd/varsxx.bat.in" "${ENV_SCRIPT_NAME}" @ONLY)

  install(
    PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/${ENV_SCRIPT_NAME}"
    DESTINATION "${ONEAPI_INSTALL_ENVDIR}"
    COMPONENT dev)
else()
  file(TO_CMAKE_PATH "${env_rel_prefix}" env_rel_prefix)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_INCLUDEDIR}" _install_includedir)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_LIBDIR}" _install_libdir)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_BINDIR}" _install_bindir)
  file(TO_CMAKE_PATH "${ONEAPI_INSTALL_PKGCONFIGDIR}" _install_pkgconfigdir)
  set(ENV_SCRIPT_NAME "vars.sh")
  configure_file("sh/vars.sh.in" "${ENV_SCRIPT_NAME}" @ONLY)
  install(
    PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/${ENV_SCRIPT_NAME}"
    DESTINATION "${ONEAPI_INSTALL_ENVDIR}"
    COMPONENT dev)
endif()

=== examples/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
# oneAPI Video Processing Library (oneVPL) examples

cmake_minimum_required(VERSION 3.10.2)

if(BUILD_EXAMPLES)
  add_subdirectory(coreAPI/legacy-decode)
  add_subdirectory(coreAPI/legacy-vpp)
  add_subdirectory(coreAPI/legacy-encode)
  add_subdirectory(hello/hello-createsession)
  add_subdirectory(hello/hello-decode)
  add_subdirectory(hello/hello-decvpp)
  add_subdirectory(hello/hello-encode)
  add_subdirectory(hello/hello-transcode)
  add_subdirectory(hello/hello-vpp)
endif()

if(INSTALL_EXAMPLE_CODE)
  install(
    DIRECTORY content
    DESTINATION ${ONEAPI_INSTALL_EXAMPLEDIR}
    COMPONENT dev)

  install(
    DIRECTORY coreAPI/legacy-decode coreAPI/legacy-vpp coreAPI/legacy-encode
    DESTINATION ${ONEAPI_INSTALL_EXAMPLEDIR}/coreAPI
    COMPONENT dev)

  install(
    DIRECTORY interop/vpl-infer interop/dpcpp-blur
    DESTINATION ${ONEAPI_INSTALL_EXAMPLEDIR}/interop
    COMPONENT dev)

  install(
    DIRECTORY hello/hello-createsession hello/hello-decode hello/hello-decvpp
              hello/hello-encode hello/hello-transcode hello/hello-vpp
    DESTINATION ${ONEAPI_INSTALL_EXAMPLEDIR}/hello
    COMPONENT dev)
endif()

=== modulefiles/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)

if(UNIX)
  install(
    PROGRAMS vpl
    DESTINATION ${ONEAPI_INSTALL_MODFILEDIR}
    COMPONENT dev)
endif()

=== preview/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)

=== tools/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

cmake_minimum_required(VERSION 3.10.2)

add_subdirectory(cli)
add_subdirectory(legacy)

=== dispatcher/test/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)

add_subdirectory(runtimes/stub)
add_subdirectory(runtimes/stub1x)

# Build googletest
set(BUILD_SHARED_LIBS OFF)

set(BUILD_GMOCK
    OFF
    CACHE BOOL "" FORCE)
set(INSTALL_GTEST
    OFF
    CACHE BOOL "" FORCE)
set(gtest_disable_pthreads
    OFF
    CACHE BOOL "" FORCE)
set(gtest_force_shared_crt
    ON
    CACHE BOOL "" FORCE)
set(gtest_hide_internal_symbols
    OFF
    CACHE BOOL "" FORCE)

#
add_subdirectory(ext/googletest)
add_library(GTest::gtest ALIAS gtest)
add_library(GTest::gtest_main ALIAS gtest_main)

add_subdirectory(unit)
add_subdirectory(vpl-timing)
add_subdirectory(mfxinit-test)

=== tools/cli/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

add_subdirectory(system_analyzer)

add_executable(vpl-inspect vpl-inspect.cpp)
target_link_libraries(vpl-inspect VPL)
target_include_directories(vpl-inspect PRIVATE ${ONEVPL_API_HEADER_DIRECTORY})

if(BUILD_TOOLS_ONEVPL_EXPERIMENTAL)
  target_compile_definitions(vpl-inspect PRIVATE -DONEVPL_EXPERIMENTAL)
endif()

install(TARGETS vpl-inspect RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
                                    COMPONENT dev)

=== tools/legacy/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2018 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
# oneAPI Video Processing Library (oneVPL) main build script

add_subdirectory(media_sdk_compatibility_headers)
add_subdirectory(sample_common)
add_subdirectory(sample_decode)
add_subdirectory(sample_vpp)
add_subdirectory(sample_encode)
add_subdirectory(sample_multi_transcode)
add_subdirectory(sample_misc/wayland)
add_subdirectory(metrics_monitor)

=== dispatcher/test/mfxinit-test/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif()

add_executable(mfxinit-test main.cpp)
target_link_libraries(mfxinit-test VPL)
target_include_directories(mfxinit-test PRIVATE ${ONEVPL_API_HEADER_DIRECTORY})

=== dispatcher/test/unit/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)

project(${PROJECT_NAME}Tests LANGUAGES CXX)

set(test_sources
    src/session-test.cpp
    src/legacycpp-session-test-1x.cpp
    src/legacycpp-session-test-2x.cpp
    src/main.cpp
    src/dispatcher_common.cpp
    src/dispatcher_common_multiprop.cpp
    src/dispatcher_enum_impls.cpp
    src/dispatcher_gpu.cpp
    src/dispatcher_low_latency.cpp
    src/dispatcher_stub.cpp
    src/dispatcher_sw.cpp
    src/dispatcher_sw_multiprop.cpp
    src/dispatcher_util.cpp
    src/experimental_api.cpp)
add_executable(${PROJECT_NAME} ${test_sources})

find_package(VPL REQUIRED)
target_link_libraries(${PROJECT_NAME} PUBLIC GTest::gtest VPL::dispatcher)

target_include_directories(${PROJECT_NAME} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

if(WIN32)
  target_link_libraries(${PROJECT_NAME} PUBLIC shlwapi.lib)
endif()

include(GoogleTest)
gtest_discover_tests(${PROJECT_NAME} PROPERTIES ENVIRONMENT
                     ONEVPL_SEARCH_PATH=$<TARGET_FILE_DIR:vplstubrt>)

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
		-DONEAPI_INSTALL_ENVDIR=/usr/share/vpl/env \
		-DONEAPI_INSTALL_MODFILEDIR=/usr/share/vpl/modulefiles

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/tmp/usr/share/doc/oneVPL/license.txt \
		debian/tmp/usr/share/doc/oneVPL/third-party-programs.txt \
		debian/tmp/usr/share/oneVPL/examples

## onevpl 2023.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,11 +4,9 @@
 # SPDX-License-Identifier: MIT
 # ##############################################################################
 # oneAPI Video Processing Library (oneVPL) main build script
+cmake_minimum_required(VERSION 3.13.0)
 if(MSVC)
-  cmake_minimum_required(VERSION 3.15)
   cmake_policy(SET CMP0091 NEW)
-else()
-  cmake_minimum_required(VERSION 3.10.2)
 endif()
 
 file(STRINGS "version.txt" version_txt)
@@ -44,13 +42,6 @@
   endif()
 endif()
 
-# WA for missing definition in 32-bit arm-linux compiler
-string(FIND ${CMAKE_CXX_COMPILER} "arm-linux" IS_ARM_32BIT)
-if(${IS_ARM_32BIT} GREATER_EQUAL 0)
-  message(STATUS "Setting __ILP32__")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__ILP32__")
-endif()
-
 # Project options
 option(BUILD_SHARED_LIBS "Build shared instead of static libraries." ON)
 option(BUILD_TESTS "Build tests." OFF)
@@ -106,14 +97,12 @@
   set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
 endif()
 
-option(USE_ONEAPI_INSTALL_LAYOUT "Use oneAPI install layout instead of FHS" OFF)
-
 # Set output directories
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
 set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
 
-include(cmake/oneAPIInstallDirs.cmake)
+include(cmake/InstallDirs.cmake)
 
 # Set POSITION_INDEPENDENT_CODE property for all targets
 set(CMAKE_POSITION_INDEPENDENT_CODE true)
@@ -141,22 +130,14 @@
 
 install(
   FILES third-party-programs.txt
-  DESTINATION ${ONEAPI_INSTALL_LICENSEDIR}
+  DESTINATION ${VPL_INSTALL_LICENSEDIR}
   COMPONENT license)
 
 install(
   FILES LICENSE
   RENAME license.txt
-  DESTINATION ${ONEAPI_INSTALL_LICENSEDIR}
+  DESTINATION ${VPL_INSTALL_LICENSEDIR}
   COMPONENT license)
-
-if(USE_ONEAPI_INSTALL_LAYOUT)
-  install(
-    FILES LICENSE
-    RENAME license.txt
-    DESTINATION "licensing"
-    COMPONENT license)
-endif()
 
 include(cmake/PackageTarget.cmake)
 set(CMAKE_INSTALL_SYSTEM_RUNTIME_COMPONENT runtime)
@@ -208,23 +189,18 @@
 message(
   STATUS "  CMAKE_INSTALL_FULL_DOCDIR       : ${CMAKE_INSTALL_FULL_DOCDIR}")
 message(
-  STATUS
-    "  ONEAPI_INSTALL_FULL_PKGCONFIGDIR: ${ONEAPI_INSTALL_FULL_PKGCONFIGDIR}")
-message(
-  STATUS "  ONEAPI_INSTALL_FULL_CMAKEDIR    : ${ONEAPI_INSTALL_FULL_CMAKEDIR}")
-message(
-  STATUS "  ONEAPI_INSTALL_FULL_ENVDIR      : ${ONEAPI_INSTALL_FULL_ENVDIR}")
-message(
-  STATUS "  ONEAPI_INSTALL_FULL_MODFILEDIR  : ${ONEAPI_INSTALL_FULL_MODFILEDIR}"
-)
-message(
-  STATUS "  ONEAPI_INSTALL_FULL_EXAMPLEDIR  : ${ONEAPI_INSTALL_FULL_EXAMPLEDIR}"
-)
-message(
-  STATUS "  ONEAPI_INSTALL_FULL_LICENSEDIR  : ${ONEAPI_INSTALL_FULL_LICENSEDIR}"
-)
-message(
-  STATUS "  ONEAPI_INSTALL_FULL_PYTHONDIR   : ${ONEAPI_INSTALL_FULL_PYTHONDIR}")
+  STATUS "  VPL_INSTALL_FULL_PKGCONFIGDIR   : ${VPL_INSTALL_FULL_PKGCONFIGDIR}")
+message(
+  STATUS "  VPL_INSTALL_FULL_CMAKEDIR       : ${VPL_INSTALL_FULL_CMAKEDIR}")
+message(STATUS "  VPL_INSTALL_FULL_ENVDIR         : ${VPL_INSTALL_FULL_ENVDIR}")
+message(
+  STATUS "  VPL_INSTALL_FULL_MODFILEDIR     : ${VPL_INSTALL_FULL_MODFILEDIR}")
+message(
+  STATUS "  VPL_INSTALL_FULL_EXAMPLEDIR     : ${VPL_INSTALL_FULL_EXAMPLEDIR}")
+message(
+  STATUS "  VPL_INSTALL_FULL_LICENSEDIR     : ${VPL_INSTALL_FULL_LICENSEDIR}")
+message(
+  STATUS "  VPL_INSTALL_FULL_PYTHONDIR      : ${VPL_INSTALL_FULL_PYTHONDIR}")
 message(STATUS "Build:")
 message(
   STATUS "  BUILD_DISPATCHER_ONLY                : ${BUILD_DISPATCHER_ONLY}")

=== api/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
# oneAPI Video Processing Library (oneVPL) API build script
cmake_minimum_required(VERSION 3.13.0)

set(VPL_API_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

if(DEFINED ENV{ONEVPL_API_HEADER_DIRECTORY})
  set(VPL_API_INCLUDE_DIR $ENV{ONEVPL_API_HEADER_DIRECTORY})
  message(STATUS "Using custom API header directory: ${VPL_API_INCLUDE_DIR}")
endif()

# get API version
file(READ ${VPL_API_INCLUDE_DIR}/vpl/mfxdefs.h mfxdefs)

string(REGEX MATCH "MFX_VERSION_MAJOR ([0-9]*)" _ ${mfxdefs})
set(API_VERSION_MAJOR ${CMAKE_MATCH_1})
set(API_VERSION_MAJOR
    ${API_VERSION_MAJOR}
    PARENT_SCOPE)

string(REGEX MATCH "MFX_VERSION_MINOR ([0-9]*)" _ ${mfxdefs})
set(API_VERSION_MINOR ${CMAKE_MATCH_1})
set(API_VERSION_MINOR
    ${API_VERSION_MINOR}
    PARENT_SCOPE)

message(STATUS "API version: ${API_VERSION_MAJOR}.${API_VERSION_MINOR}")
add_library(vpl-api INTERFACE)

target_include_directories(vpl-api INTERFACE ${VPL_API_INCLUDE_DIR})

if(BUILD_DEV)
  install(
    DIRECTORY ${VPL_API_INCLUDE_DIR}/vpl
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    COMPONENT dev)
endif()

=== dispatcher/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # SPDX-License-Identifier: MIT
 # ##############################################################################
-cmake_minimum_required(VERSION 3.10.2)
+cmake_minimum_required(VERSION 3.13.0)
 set(TARGET VPL)
 set(OUTPUT_NAME "vpl")
 set(DLL_PREFIX "lib")

=== env/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)

file(RELATIVE_PATH env_rel_prefix "${VPL_INSTALL_FULL_ENVDIR}"
     "${CMAKE_INSTALL_PREFIX}")
# remove trailing slash
string(REGEX REPLACE "\/$" "" env_rel_prefix "${env_rel_prefix}")

# convert to native path
file(TO_NATIVE_PATH "${env_rel_prefix}" env_rel_prefix)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_INCLUDEDIR}" _install_includedir)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_LIBDIR}" _install_libdir)
file(TO_NATIVE_PATH "${CMAKE_INSTALL_BINDIR}" _install_bindir)
file(TO_NATIVE_PATH "${VPL_INSTALL_EXAMPLEDIR}" _install_exampledir)

if(WIN32)
  install(
    PROGRAMS "cmd/vars.bat"
    DESTINATION "${VPL_INSTALL_ENVDIR}"
    COMPONENT dev)

  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(ENV_SCRIPT_NAME "vars64.bat")
  elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
    set(ENV_SCRIPT_NAME "vars32.bat")
  endif()
  configure_file("cmd/varsxx.bat.in" "${ENV_SCRIPT_NAME}" @ONLY)

  install(
    PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/${ENV_SCRIPT_NAME}"
    DESTINATION "${VPL_INSTALL_ENVDIR}"
    COMPONENT dev)
else()
  file(TO_CMAKE_PATH "${env_rel_prefix}" env_rel_prefix)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_INCLUDEDIR}" _install_includedir)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_LIBDIR}" _install_libdir)
  file(TO_CMAKE_PATH "${CMAKE_INSTALL_BINDIR}" _install_bindir)
  file(TO_CMAKE_PATH "${VPL_INSTALL_PKGCONFIGDIR}" _install_pkgconfigdir)
  set(ENV_SCRIPT_NAME "vars.sh")
  configure_file("sh/vars.sh.in" "${ENV_SCRIPT_NAME}" @ONLY)
  install(
    PROGRAMS "${CMAKE_CURRENT_BINARY_DIR}/${ENV_SCRIPT_NAME}"
    DESTINATION "${VPL_INSTALL_ENVDIR}"
    COMPONENT dev)
endif()

=== examples/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
# oneAPI Video Processing Library (oneVPL) examples

cmake_minimum_required(VERSION 3.13.0)

if(BUILD_EXAMPLES)
  add_subdirectory(api1x_core/legacy-decode)
  add_subdirectory(api1x_core/legacy-vpp)
  add_subdirectory(api1x_core/legacy-encode)
  add_subdirectory(api2x/hello-decode)
  add_subdirectory(api2x/hello-decvpp)
  add_subdirectory(api2x/hello-encode)
  add_subdirectory(api2x/hello-transcode)
  add_subdirectory(api2x/hello-vpp)
  add_subdirectory(tutorials/01_transition/VPL)
endif()

if(INSTALL_EXAMPLE_CODE)
  install(
    DIRECTORY content
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}
    COMPONENT dev)

  install(
    DIRECTORY api1x_core/legacy-decode api1x_core/legacy-vpp
              api1x_core/legacy-encode
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/api1x_core
    COMPONENT dev)

  install(
    DIRECTORY interop/vpl-infer
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/interop
    COMPONENT dev)

  install(
    DIRECTORY api2x/hello-decode api2x/hello-decvpp api2x/hello-encode
              api2x/hello-transcode api2x/hello-vpp
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/api2x
    COMPONENT dev)

  install(
    DIRECTORY tutorials/01_transition
    DESTINATION ${VPL_INSTALL_EXAMPLEDIR}/tutorials
    COMPONENT dev)
endif()

=== modulefiles/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)

if(UNIX)
  install(
    PROGRAMS vpl
    DESTINATION ${VPL_INSTALL_MODFILEDIR}
    COMPONENT dev)
endif()

=== preview/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.0)

=== tools/cli/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # SPDX-License-Identifier: MIT
 # ##############################################################################
-cmake_minimum_required(VERSION 3.10.2)
+cmake_minimum_required(VERSION 3.13.0)
 
 if(MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)

=== dispatcher/test/mfxinit-test/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # SPDX-License-Identifier: MIT
 # ##############################################################################
-cmake_minimum_required(VERSION 3.10.2)
+cmake_minimum_required(VERSION 3.13.0)
 
 if(MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)

=== dispatcher/test/unit/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # SPDX-License-Identifier: MIT
 # ##############################################################################
-cmake_minimum_required(VERSION 3.10.2)
+cmake_minimum_required(VERSION 3.13.0)
 
 project(${PROJECT_NAME}Tests LANGUAGES CXX)

=== examples/api1x_core/legacy-decode/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(legacy-decode)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET legacy-decode)
set(SOURCES src/legacy-decode.cpp)

# Set default build type to RelWithDebInfo if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(
    STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

add_executable(${TARGET} ${SOURCES})

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::dispatcher)

if(UNIX)
  set(LIBVA_SUPPORT
      ON
      CACHE BOOL "Enable hardware support.")
  if(LIBVA_SUPPORT)
    find_package(PkgConfig REQUIRED)
    # note: pkg-config version for libva is *API* version
    pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
    pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
    if(PKG_LIBVA_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
      set(THREADS_PREFER_PTHREAD_FLAG TRUE)
      find_package(Threads REQUIRED)
      target_link_libraries(${TARGET} PkgConfig::PKG_LIBVA
                            PkgConfig::PKG_LIBVA_DRM Threads::Threads)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
    else()
      message(
        SEND_ERROR
          "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
      )
    endif()
  else()
    message(STATUS "Building ${TARGET} without hardware support")
  endif()
endif()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")
add_test(NAME ${TARGET}-test COMMAND ${TARGET} -i
                                     "${VPL_CONTENT_DIR}/cars_320x240.h265")

=== examples/api1x_core/legacy-vpp/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.13.0)
project(legacy-vpp)

# Default install places 64 bit runtimes in the environment, so we want to do a
# 64 bit build by default.
if(WIN32)
  if(NOT DEFINED CMAKE_GENERATOR_PLATFORM)
    set(CMAKE_GENERATOR_PLATFORM
        x64
        CACHE STRING "")
    message(STATUS "Generator Platform set to ${CMAKE_GENERATOR_PLATFORM}")
  endif()
endif()

set(TARGET legacy-vpp)
set(SOURCES src/legacy-vpp.cpp)

# Set default build type to RelWithDebInfo if not specified
if(NOT CMAKE_BUILD_TYPE)
  message(
    STATUS "Default CMAKE_BUILD_TYPE not set using Release with Debug Info")
  set(CMAKE_BUILD_TYPE
      "RelWithDebInfo"
      CACHE
        STRING
        "Choose build type from: None Debug Release RelWithDebInfo MinSizeRel"
        FORCE)
endif()

add_executable(${TARGET} ${SOURCES})

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  if(NOT DEFINED ENV{VSCMD_VER})
    set(CMAKE_MSVCIDE_RUN_PATH $ENV{PATH})
  endif()
endif()

find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::dispatcher)

if(UNIX)
  set(LIBVA_SUPPORT
      ON
      CACHE BOOL "Enable hardware support.")
  if(LIBVA_SUPPORT)
    find_package(PkgConfig REQUIRED)
    # note: pkg-config version for libva is *API* version
    pkg_check_modules(PKG_LIBVA IMPORTED_TARGET libva>=1.2)
    pkg_check_modules(PKG_LIBVA_DRM IMPORTED_TARGET libva-drm>=1.2)
    if(PKG_LIBVA_FOUND)
      target_compile_definitions(${TARGET} PUBLIC -DLIBVA_SUPPORT)
      set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
      set(THREADS_PREFER_PTHREAD_FLAG TRUE)
      find_package(Threads REQUIRED)
      target_link_libraries(${TARGET} PkgConfig::PKG_LIBVA
                            PkgConfig::PKG_LIBVA_DRM Threads::Threads)
      target_include_directories(${TARGET} PUBLIC ${PKG_LIBVA_INCLUDE_DIRS})
    else()
      message(
        SEND_ERROR
          "libva not found: set LIBVA_SUPPORT=OFF to build ${TARGET} without libva support"
      )
    endif()
  else()
    message(STATUS "Building ${TARGET} without hardware support")
  endif()
endif()

include(CTest)
set(VPL_CONTENT_DIR
    ${CMAKE_CURRENT_SOURCE_DIR}/../../content
    CACHE PATH "Path to content.")
if(IMPL_ARG EQUAL -hw)
  set(content_file cars_320x240.nv12)
else()
  set(content_file cars_320x240.i420)
endif()
add_test(NAME ${TARGET}-test
         COMMAND ${TARGET} -i "${VPL_CONTENT_DIR}/${content_file}" -w 320 -h
                 240)

=== debian/changelog ===
onevpl (2023.3.0-1build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:47:48 +0200

=== debian/control ===
Source: onevpl
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libdrm-dev,
 libva-dev,
 libwayland-dev,
 libx11-dev,
 libx11-xcb-dev,
 libxcb1-dev,
 libxcb-dri3-dev,
 libxcb-present-dev,
 pkg-config,
 wayland-protocols,
Standards-Version: 4.6.0
Homepage: https://github.com/oneapi-src/oneVPL
Vcs-Browser: https://salsa.debian.org/debian/onevpl
Vcs-Git: https://salsa.debian.org/debian/onevpl.git
Rules-Requires-Root: no

Package: libvpl2
Architecture: amd64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: oneAPI Video Processing Library -- shared library
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes the dispatcher library

Package: libvpl-dev
Architecture: amd64 x32
Depends:
 libvpl2 (= ${binary:Version}),
 ${misc:Depends},
Description: oneAPI Video Processing Library -- development files
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes header files and examples for development.

Package: onevpl-tools
Architecture: amd64 x32
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: oneAPI Video Processing Library -- command line tools
 The oneAPI Video Processing Library (oneVPL) provides a single video processing
 API for encode, decode, and video processing that works across a wide range of
 accelerators.
 .
 This repository contains the following components of oneVPL:
 .
  - Copies of the oneVPL Specification API header files
  - oneVPL dispatcher
  - Examples demonstrating API usage
  - oneVPL command line tools
 .
 This project is part of the larger oneAPI project.
 .
 This package includes the command line tools.

=== debian/rules ===
--- 
+++ 
@@ -6,8 +6,8 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DONEAPI_INSTALL_ENVDIR=/usr/share/vpl/env \
-		-DONEAPI_INSTALL_MODFILEDIR=/usr/share/vpl/modulefiles
+		-DVPL_INSTALL_ENVDIR=/usr/share/vpl/env \
+		-DVPL_INSTALL_MODFILEDIR=/usr/share/vpl/modulefiles
 
 override_dh_auto_install:
 	dh_auto_install

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%onevpl-$1.tar.gz%" \
   https://github.com/oneapi-src/oneVPL/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
